# coding: utf-8

"""
    Corbado Backend API

     # Introduction This documentation gives an overview of all Corbado Backend API calls to implement passwordless authentication with Passkeys. 

    The version of the OpenAPI document: 2.0.0
    Contact: support@corbado.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from corbado_python_sdk.generated.models.connect_token_data_passkey_append import ConnectTokenDataPasskeyAppend
from corbado_python_sdk.generated.models.connect_token_data_passkey_delete import ConnectTokenDataPasskeyDelete
from corbado_python_sdk.generated.models.connect_token_data_passkey_list import ConnectTokenDataPasskeyList
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

CONNECTTOKENDATA_ONE_OF_SCHEMAS = ["ConnectTokenDataPasskeyAppend", "ConnectTokenDataPasskeyDelete", "ConnectTokenDataPasskeyList"]

class ConnectTokenData(BaseModel):
    """
    ConnectTokenData
    """
    # data type: ConnectTokenDataPasskeyAppend
    oneof_schema_1_validator: Optional[ConnectTokenDataPasskeyAppend] = None
    # data type: ConnectTokenDataPasskeyDelete
    oneof_schema_2_validator: Optional[ConnectTokenDataPasskeyDelete] = None
    # data type: ConnectTokenDataPasskeyList
    oneof_schema_3_validator: Optional[ConnectTokenDataPasskeyList] = None
    actual_instance: Optional[Union[ConnectTokenDataPasskeyAppend, ConnectTokenDataPasskeyDelete, ConnectTokenDataPasskeyList]] = None
    one_of_schemas: Set[str] = { "ConnectTokenDataPasskeyAppend", "ConnectTokenDataPasskeyDelete", "ConnectTokenDataPasskeyList" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ConnectTokenData.model_construct()
        error_messages = []
        match = 0
        # validate data type: ConnectTokenDataPasskeyAppend
        if not isinstance(v, ConnectTokenDataPasskeyAppend):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ConnectTokenDataPasskeyAppend`")
        else:
            match += 1
        # validate data type: ConnectTokenDataPasskeyDelete
        if not isinstance(v, ConnectTokenDataPasskeyDelete):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ConnectTokenDataPasskeyDelete`")
        else:
            match += 1
        # validate data type: ConnectTokenDataPasskeyList
        if not isinstance(v, ConnectTokenDataPasskeyList):
            error_messages.append(f"Error! Input type `{type(v)}` is not `ConnectTokenDataPasskeyList`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ConnectTokenData with oneOf schemas: ConnectTokenDataPasskeyAppend, ConnectTokenDataPasskeyDelete, ConnectTokenDataPasskeyList. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ConnectTokenData with oneOf schemas: ConnectTokenDataPasskeyAppend, ConnectTokenDataPasskeyDelete, ConnectTokenDataPasskeyList. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into ConnectTokenDataPasskeyAppend
        try:
            instance.actual_instance = ConnectTokenDataPasskeyAppend.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ConnectTokenDataPasskeyDelete
        try:
            instance.actual_instance = ConnectTokenDataPasskeyDelete.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into ConnectTokenDataPasskeyList
        try:
            instance.actual_instance = ConnectTokenDataPasskeyList.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ConnectTokenData with oneOf schemas: ConnectTokenDataPasskeyAppend, ConnectTokenDataPasskeyDelete, ConnectTokenDataPasskeyList. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ConnectTokenData with oneOf schemas: ConnectTokenDataPasskeyAppend, ConnectTokenDataPasskeyDelete, ConnectTokenDataPasskeyList. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], ConnectTokenDataPasskeyAppend, ConnectTokenDataPasskeyDelete, ConnectTokenDataPasskeyList]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


