# coding: utf-8

"""
    Corbado Backend API

     # Introduction This documentation gives an overview of all Corbado Backend API calls to implement passwordless authentication with Passkeys. 

    The version of the OpenAPI document: 2.0.0
    Contact: support@corbado.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from corbado_python_sdk.generated.models.passkey_event_type import PasskeyEventType
from typing import Optional, Set
from typing_extensions import Self

class PasskeyEvent(BaseModel):
    """
    PasskeyEvent
    """ # noqa: E501
    passkey_event_id: StrictStr = Field(alias="passkeyEventID")
    user_id: StrictStr = Field(description="ID of the user", alias="userID")
    event_type: PasskeyEventType = Field(alias="eventType")
    client_env_id: Optional[StrictStr] = Field(default=None, alias="clientEnvID")
    process_id: Optional[StrictStr] = Field(default=None, alias="processID")
    credential_id: Optional[StrictStr] = Field(default=None, alias="credentialID")
    expires: Optional[StrictInt] = None
    created: StrictStr = Field(description="Timestamp of when the entity was created in yyyy-MM-dd'T'HH:mm:ss format")
    __properties: ClassVar[List[str]] = ["passkeyEventID", "userID", "eventType", "clientEnvID", "processID", "credentialID", "expires", "created"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PasskeyEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PasskeyEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "passkeyEventID": obj.get("passkeyEventID"),
            "userID": obj.get("userID"),
            "eventType": obj.get("eventType"),
            "clientEnvID": obj.get("clientEnvID"),
            "processID": obj.get("processID"),
            "credentialID": obj.get("credentialID"),
            "expires": obj.get("expires"),
            "created": obj.get("created")
        })
        return _obj


