# coding: utf-8

"""
    Corbado Backend API

     # Introduction This documentation gives an overview of all Corbado Backend API calls to implement passwordless authentication with Passkeys. 

    The version of the OpenAPI document: 2.0.0
    Contact: support@corbado.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List
from corbado_python_sdk.generated.models.decision_tag import DecisionTag
from corbado_python_sdk.generated.models.detection_tag import DetectionTag
from typing import Optional, Set
from typing_extensions import Self

class PasskeyLoginStartRsp(BaseModel):
    """
    PasskeyLoginStartRsp
    """ # noqa: E501
    login_allow: StrictBool = Field(alias="loginAllow")
    detection_tags: List[DetectionTag] = Field(alias="detectionTags")
    decision_tag: DecisionTag = Field(alias="decisionTag")
    assertion_options: StrictStr = Field(alias="assertionOptions")
    is_cda_candidate: StrictBool = Field(alias="isCDACandidate")
    __properties: ClassVar[List[str]] = ["loginAllow", "detectionTags", "decisionTag", "assertionOptions", "isCDACandidate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PasskeyLoginStartRsp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in detection_tags (list)
        _items = []
        if self.detection_tags:
            for _item_detection_tags in self.detection_tags:
                if _item_detection_tags:
                    _items.append(_item_detection_tags.to_dict())
            _dict['detectionTags'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PasskeyLoginStartRsp from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "loginAllow": obj.get("loginAllow"),
            "detectionTags": [DetectionTag.from_dict(_item) for _item in obj["detectionTags"]] if obj.get("detectionTags") is not None else None,
            "decisionTag": obj.get("decisionTag"),
            "assertionOptions": obj.get("assertionOptions"),
            "isCDACandidate": obj.get("isCDACandidate")
        })
        return _obj


